var MISSING = "missing";
var EMPTY = "";
var errMsg = "";
var type = "";

function updateErrMsg(t) {
	errMsg += "<li>" + t + "</li>";
}

function checkLength(o, min, max, msg) {
	if (o.val().trim().length > max || o.val().trim().length < min) {
		o.addClass("error");
		updateErrMsg(msg);
		return false;
	} else {
		o.removeClass("error");
		return true;
	}
}

function checkEmpty(o, t, msg) {
	if(t == "r"){
		if (o.val() == 0) {
			o.addClass("error");
			updateErrMsg(msg);
			return false;
		} else {
			o.removeClass("error");
			return true;
		}
	}
	else{
		if (o.val().trim().length == 0) {
			o.addClass("error");
			updateErrMsg(msg);
			return false;
		} else {
			o.removeClass("error");
			return true;
		}
	}

}

function checkRegexp(o, regexp, n) {
	if (!(regexp.test(o.val()))) {
		o.addClass("error");
		updateErrMsg(n);
		return false;
	} else {
		o.removeClass("error");
		return true;
    }
}

function LoadingMessage(tmsg){
    $.mobile.loading('show', {
         text: tmsg,
         textVisible: true,
         html: ""
     });
}

function HideMessage(){
    $.mobile.loading('hide');
}

function ShowDialog(containerId, msg, msgType){
	type = msgType;
	$("#" + containerId).simpledialog({
		"mode" : "bool",
		"prompt" : "<br/>" + msg + "<br/>",
		"useModal": true,
		"buttons" : {  
			"OK": {  
				click: function () {
					if(type == "forpass"){
						ResetForgotPassword();
						window.location.href = "index.html";
					}
				}  
			} 
		},
		"pickPageTheme": "a",
		"pickPageButtonTheme":"a"
	})
}

function ResetForgotPassword(){
    $("#txtUserName", "#forgotpassword").val("");
    $("#txtNewPassword", "#forgotpassword").val("");
    $("#txtRePassword", "#forgotpassword").val("");
    $("#passInputError", "#forgotpassword").html('').hide();
}

function ValidateLogin(){
	LoadingMessage("Validating login detail...");
    $("#errMessage", "#login").hide().html('');
	var user = ($("#txtUserName", "#login").val()).trim();
	var pass = ($("#txtPassword", "#login").val()).trim();
    if(user == '' &&  pass == ''){
        $("#errMessage").html("Username and password cannot be blank");
        $("#errMessage").show();
				HideMessage();
    }
    else if(user == '' &&  pass != ''){
        $("#errMessage", "#login").html("Username cannot be blank");
        $("#errMessage", "#login").show();
				HideMessage();
    }
    
    else if(user != '' &&  pass == ''){
        $("#errMessage", "#login").html("Password cannot be blank");
        $("#errMessage", "#login").show();
				HideMessage();
    }
    else{
        if(user != '' &&  pass != ''){
			ValidateOnlineLogin(user, pass, function(data){
				if(data == 'true'){
					window.location.href = "home.html";
					HideMessage();
				}
				else{
					$("#errMessage", "#login").html("Username or password is incorrect");
					$("#errMessage", "#login").show();
					HideMessage();
				}
			});
        }
        else{
            $("#errMessage", "#login").html("Username or password is incorrect");
            $("#errMessage", "#login").show();
			HideMessage();
        }
    }
	
}

function ValidatePassword(){
	LoadingMessage("Updating password...");
	errMsg = EMPTY;
	$("#passInputError", "#forgotpassword").html('').hide();
	var username = $("#txtUserName", "#forgotpassword"),
		newpassword = $("#txtNewPassword", "#forgotpassword"),
		repassword = $("#txtRePassword", "#forgotpassword"),
		bValid = true;
	
	if(!checkEmpty(username, "", "Username cannot be empty.")){
		bValid = false;
	}	
	else if(!checkLength(username, 3, 16, "Username has to contain 3-15 characters.")){
		bValid = false;
	}
	if(!checkEmpty(newpassword, "", "New password cannot be empty.")){
		bValid = false;
	}
	else if(!checkLength(newpassword, 6, 16, "New password has to contain atleast 6 characters.")){
		bValid = false;
	}
	
	if(!checkEmpty(repassword, "", "Retype password cannot be empty.")){
		bValid = false;
	}
	else if(!checkLength(repassword, 6, 16, "Retype password has to contain atleast 6 characters.")){
		bValid = false;
	}
	
	if(bValid){
		if(newpassword.val().trim() != repassword.val().trim()){
			errMsg = "New password and retype password are not same.";
		}
	}
	
	if(bValid && errMsg === EMPTY){
		//Register
		ForgotPassword(username.val().trim(), newpassword.val().trim(), function(data){
			if(data == 'true'){
				HideMessage();
				ShowDialog("popupForgotPassword", "Your password has been created successfully. You may now log in with your new password", "forpass");
			}
			else if(data == 'false'){
				HideMessage();
				ShowDialog("popupForgotPassword", "Failed to change your password.Please try again!", "err");
			}
			else{
				HideMessage();
				ShowDialog("popupForgotPassword", data, "err");
			}
		});
	}
	else{
		//ErrMsg
		$("#passInputError", "#forgotpassword").html(errMsg);
		$("#passInputError", "#forgotpassword").show();
		$('html, body').animate({scrollTop:$("#passInputError", "#forgotpassword").offset().top}, 'slow');
		HideMessage();
	}
}

function RedirectLogin(){
	ResetForgotPassword();
	window.location.href = "index.html";
}

webUrl ="http://smashfit4kids.com/test.php";//"http://man302.net76.net/test1.php";//
function ValidateOnlineLogin(username, password, callback){
   $.post(webUrl, { type: "Login", uid: username, pass: password},
        function(data) {
            localStorage.setItem("user", username);
            callback(data);
   }).error(function() { return callback("error"); });
}

function ForgotPassword(username, password, callback){
   $.post(webUrl, { type: "ForgotPassword", uid: username, pass: password},
        function(data) {
            callback(data);
   }).error(function() { return callback("error"); });
}

$('#forgotpassword').live('pageshow', function() {
	$("#passInputError", "#forgotpassword").html('').hide();
});

$(document).on('pageinit','#splash',function(){ // the .on() method does require jQuery 1.7 + but this will allow you to have the contained code only run when the #splash page is initialized.
    $.support.cors = true;
    $.mobile.allowCrossDomainPages=true;
    setTimeout(function(){
        window.location.href = "index.html";
    }, 5000);
});

